/* See LICENSE.TXT */

var prefs, ISupports, IStr, windowmanager;

const bodyPref = "ljpost.body";
const subjectPref = "ljpost.subj";
const tabPref = "ljpost.openInNewTab";
const bgPref = "ljpost.openInBackground";
const dsPref = "ljpost.openInDeepestSender";

const defaultBody = "<a href=\"%url%\">%title%</a>%ifSelection%:\n\n\"%selection%\"\n%endifSelection%";
const defaultSubject = "";
const defaultTabPref = false;
const defaultBgPref = false;
const defaultDSPref = false;

function getWinByType(type) {
    if (!windowmanager) {
	windowmanager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	windowmanager = windowmanager.QueryInterface( Components.interfaces.nsIWindowMediator);
    }

    return windowmanager.getMostRecentWindow(type);
}

var isDSInstalled = null;

// hope i wrote it correctly :)
function isDeepestSenderInstalled() {
  var rdf, datasource, target, property, node;

  if (isDSInstalled != null)
     return isDSInstalled;

  rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService); 
  datasource = rdf.GetDataSource("rdf:chrome");
  node = rdf.GetResource("urn:mozilla:package:deepestsender");
  property = rdf.GetResource("http://www.mozilla.org/rdf/chrome#name");

  target = datasource.GetTarget(node, property, true);
  
  isDSInstalled = target ? true:false;

  return isDSInstalled;
}

function connectPrefs() {
  if (prefs)
    return;

  prefs = Components.classes["@mozilla.org/preferences-service;1"]
	.getService(Components.interfaces.nsIPrefBranch);

  if(Components.classes["@mozilla.org/supports-wstring;1"]) {
    ISupports = "@mozilla.org/supports-wstring;1";
    IStr = Components.interfaces.nsISupportsWString;
  } else {
    ISupports = "@mozilla.org/supports-string;1";
    IStr = Components.interfaces.nsISupportsString;
  }
}

function getPref(prefAddr, defaultValue) {
  var value;

  connectPrefs();
  try {
    value = prefs.getComplexValue(prefAddr, IStr);
    return value.data;
  } catch (ex) {
    setPref(prefAddr, defaultValue);
    return defaultValue;
  }
}

function setPref(prefAddr, value) {
  var str;

  connectPrefs();
  try {
     var str = Components.classes[ISupports].createInstance(IStr);
     str.data = value;
     prefs.setComplexValue(prefAddr, IStr, str);
  } catch (ex) { }
}

function setBooleanPref(prefAddr, value) {
  connectPrefs();
  try {
    prefs.setBoolPref(prefAddr, value);
  } catch (ex) { }
}

function getBooleanPref(prefAddr, defaultValue) {
  connectPrefs();
  try {
    return prefs.getBoolPref(prefAddr);
  } catch (ex) {
    setBooleanPref(prefAddr, defaultValue);
    return defaultValue;
  }
}
