/* See LICENSE.TXT */

var menuItems = new Array("ljpost-sep", "ljpost-ljpost");
var ljptr, interval, body, subject

function init() {
  var menu = document.getElementById("contentAreaContextMenu");
  menu.addEventListener("popupshowing",showhide,false);
}

function showhide() {
  for(var i=0; i<menuItems.length; i++) {
    var menuitem = document.getElementById(menuItems[i]);
    if (menuitem)
      menuitem.hidden = false;
  }
}

function expand(template) {
  var target = window.content.document;
  var result = template;

  result = result.replace(/%url%/gi, target.location.href);

  if (target.title)
    result = result.replace(/%title%/gi, target.title);
  else
    result = result.replace(/%title%/gi, target.location.href);

  if (gContextMenu.searchSelected()) {
    result = result.replace(/%ifSelection%/gi,"");
    result = result.replace(/%endifSelection%/gi,"");
    result = result.replace(/%selection%/gi, gContextMenu.searchSelected());
  } else {
    result = result.replace(/%ifSelection%[\s\S]*%endifSelection%/gi,"");
  } 

  return result;
}

function post(e) {
  var ljURL = "http://www.livejournal.com/update.bml?mode=full";
  var browser = document.getElementById("content");
  var tabs, panels, i, tab, ds;

  if (window.content.location.href=="about:blank")
    return;

  body = expand(getPref(bodyPref, defaultBody));
  subject = expand(getPref(subjectPref, defaultSubject));

  if (getBooleanPref(dsPref, defaultDSPref)) {
      if (!isDeepestSenderInstalled()) {
        alert("Sorry, DeepestSender not installed. Please turn off this option");
	return;
      }

      toOpenWindowByType("deepestsender","chrome://deepestsender/content/");
         
      interval = setInterval("fillDeepestSender()", 200);
      return;
  }

  if (!getBooleanPref(tabPref, defaultTabPref)) {
     ljptr = window.open(ljURL, "_blank");
     if (getBooleanPref(bgPref, defaultBgPref))
	window.content.focus()
  } else {
    tab = browser.addTab(ljURL);
    if (!getBooleanPref(bgPref, defaultBgPref))
	browser.selectedTab = tab; 

    tabs = browser.mTabContainer.childNodes;
    panels = browser.mPanelContainer.childNodes;
    for (i=0;i<tabs.length;i++)
      if (tabs[i] == tab) {
	ljptr = panels[i];
	break;
      } 
  }

  interval = setInterval("fillform()", 200);
}

function fillDeepestSender() {
   var ds;

   ds = getWinByType("deepestsender");
   if (ds && ds.document.getElementById("usernametitle").value != "Deepest Sender") {
      clearInterval(interval);
      ds.document.getElementById("subject").value = subject;

      if (ds.document.getElementById("tabsource").selected) {
	  ds.document.getElementById("messagesource").value = body;
	  ds.document.getElementById("messagesource").focus();
      } else {
	  ds.document.getElementById("message").contentWindow.document.body.innerHTML = body.replace(/\n/gi,"<br>");
	  ds.document.getElementById("message").contentWindow.focus();
      }
   }
}

function fillform() {
  var doc;

  if (ljptr.tagName=="browser")
     doc = ljptr.contentDocument; // new tab
  else
     doc = ljptr.content.document; // new window

  if (doc.updateForm.event) {
      clearInterval(interval);
      doc.updateForm.event.value = body;
      doc.updateForm.subject.value = subject;
      if (!getBooleanPref(bgPref, defaultBgPref))
        doc.updateForm.event.focus();
  } 
}

window.addEventListener("load", init, false); 
