/* See LICENSE.TXT */

function onLoad() {

  if (parent.initPanel)
    parent.initPanel("chrome://ljpost/content/prefForm.xul"); 

  document.getElementById("subject").value = getPref(subjectPref, defaultSubject);
  document.getElementById("body").value = getPref(bodyPref, defaultBody);
  document.getElementById("openInNewTab").checked = getBooleanPref(tabPref, defaultTabPref);
  document.getElementById("openInBackground").checked = getBooleanPref(bgPref, defaultBgPref);

  if (isDeepestSenderInstalled()) {
      document.getElementById("openInDeepestSender").checked = getBooleanPref(dsPref, defaultDSPref);
  } else {
      document.getElementById("openInDeepestSender").checked = false;
      document.getElementById("openInDeepestSender").disabled = true;
  }
  changedDeepestSender(false);
}

function resetSettings() {
  document.getElementById("subject").value = defaultSubject;
  document.getElementById("body").value = defaultBody;
  document.getElementById("openInNewTab").checked = defaultTabPref;
  document.getElementById("openInBackground").checked = defaultBgPref;
  document.getElementById("openInDeepestSender").checked = defaultDSPref;

  changedDeepestSender(false);
}

function saveSettings() {
  setPref(subjectPref, document.getElementById("subject").value);
  setPref(bodyPref, document.getElementById("body").value);
  setBooleanPref(tabPref, document.getElementById("openInNewTab").checked);
  setBooleanPref(bgPref, document.getElementById("openInBackground").checked);
  setBooleanPref(dsPref, document.getElementById("openInDeepestSender").checked);

  return true;
}

function changedDeepestSender(fromXUL) {
  var flag = document.getElementById("openInDeepestSender").checked ^ fromXUL;

  if (document.getElementById("openInDeepestSender").disabled)
    return;

  document.getElementById("openInNewTab").disabled = flag;
  document.getElementById("openInBackground").disabled = flag;
}
